package foh.rpg.area;

import foh.rpg.character.Actor;
import foh.rpg.character.effect.EffectTimer;
import foh.rpg.character.factory.ActorPrototype;

public class SpawnPoint {

	private Cell cell;
	private EffectTimer timer;
	private ActorPrototype respawnedActor; 
	
	public SpawnPoint () {
		this.timer = new EffectTimer();
	}
	
	public void tick() {
		if (this.respawnedActor != null) {
			this.timer.tick();
			if (this.timer.expired()) {
				Actor actor = this.respawnedActor.generateActor();
				actor.setCurrentModel(this.cell.getArea().getModel());
				actor.setSpawnPoint(this);
				this.cell.setActor(actor);
				this.respawnedActor = null;
			}
		}
	}

	public void setCell(Cell cell) {
		this.cell = cell;
	}

	public Cell getCell() {
		return cell;
	}

	public void notifyDeath(Actor actor) {
		if (actor.getPrototype() != null) {
			this.respawnedActor = actor.getPrototype();
			this.timer.setExpiration(100);
			this.timer.setDuration(0);
		} else {
			// pc
		}
	}

}
