package foh.rpg.area.factory.painter;

import foh.rpg.area.Area;
import foh.rpg.character.factory.ActorFactory;
import foh.rpg.item.factory.ItemFactory;

public class CellFill extends AreaPainter {
	
	@Override
	public void paint(Area area) {
		
		for (int iX = this.getX(); iX <= this.getToX(); iX++) {
			for (int iY = this.getY(); iY <= this.getToY(); iY++) {
				
				if (this.getPrototypeCell() != null) {
					area.setTile(iX, iY, this.getPrototypeCell().getClone());
				}
				if (this.getActorKey() != null) {
					if (area.getTile()[iX][iY].isMoveThrough()) {
						area.getTile()[iX][iY].setActor(ActorFactory.getInstance().getActor(this.getActorKey()));
						area.getTile()[iX][iY].getActor().setSpawnPoint(area.getTile()[iX][iY].getSpawnPoint());
					}
				}
				if (this.getItemKey() != null) {
					if (area.getTile()[iX][iY].isMoveThrough()) {
						area.getTile()[iX][iY].getItems().add(ItemFactory.getInstance().getItem(this.getItemKey()));
					}
				}
				if (this.getPrototypePortal() != null) {
					if (area.getTile()[iX][iY].isMoveThrough()) {
						area.getTile()[iX][iY].setPortal(this.getPrototypePortal());
					}
				}
			}
		}
		
		
	}
	

	
	

}
