package foh.rpg.area.factory.painter;

import foh.rpg.area.Area;
import foh.rpg.character.factory.ActorFactory;
import foh.rpg.item.factory.ItemFactory;
import foh.rpg.util.Dice;

public class CellRandomize extends AreaPainter {
	
	private int density;

	@Override
	public void paint(Area area) {
		
		for (int i = 0; i < this.getDensity(); i++) {
			
			int iX = (new Dice(this.getX(),this.getToX())).roll();
			int iY = (new Dice(this.getY(),this.getToY())).roll();
			
			if (this.getPrototypeCell() != null) {
				area.setTile(iX, iY, this.getPrototypeCell().getClone());
			}
			if (this.getActorKey() != null) {
				if (area.getTile()[iX][iY].isMoveThrough()) {
					area.getTile()[iX][iY].setActor(ActorFactory.getInstance().getActor(this.getActorKey()));
					area.getTile()[iX][iY].getActor().setSpawnPoint(area.getTile()[iX][iY].getSpawnPoint());
				}
			}
			if (this.getItemKey() != null) {
				if (area.getTile()[iX][iY].isMoveThrough()) {
					area.getTile()[iX][iY].getItems().add(ItemFactory.getInstance().getItem(this.getItemKey()));
				}
			}
			if (this.getPrototypePortal() != null) {
				if (area.getTile()[iX][iY].isMoveThrough()) {
					area.getTile()[iX][iY].setPortal(this.getPrototypePortal());
				}
			}
		}

		
	}

	public int getDensity() {
		return this.density;
	}

	public void setDensity(int density) {
		this.density = density;
	}
	
}
