package foh.rpg.area.factory.painter;

import java.util.ArrayList;
import java.util.List;

import foh.rpg.area.Area;
import foh.rpg.area.Cell;
import foh.rpg.area.factory.AreaPrototype;
import foh.rpg.gui.Representation;

public class PaintedAreaPrototype extends AreaPrototype {
	
	private int width = 0;
	private int height = 0;
	private List<AreaPainter> drawList = null;

	public PaintedAreaPrototype() {
		this.drawList = new ArrayList<AreaPainter>();
	}

	public List<AreaPainter> getDrawList() {
		return this.drawList;
	}

	public void setDrawList(List<AreaPainter> drawList) {
		this.drawList = drawList;
	}

	public int getWidth() {
		return this.width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return this.height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	@Override
	public Area buildArea() {
		Area result = new Area(new Cell(Representation.getEmpty(), false, false,
		"XXX"), this.getWidth(), this.getHeight());

		for (AreaPainter painter : this.getDrawList()) {
			painter.paint(result);
		}
		
		return result;
	}

}
