package foh.rpg.area.factory.randomizer;

import foh.rpg.area.Area;
import foh.rpg.area.AreaPortal;
import foh.rpg.area.Cell;

public class MatrixPortalSegment extends Segment {
	
	private int[][] map = new int[9][9];
	private String portal;
	private String remoteArea;
	private String remotePortal;
	private Cell portalCell;
	
	public int[][] getMap() {
		return this.map;
	}

	public Segment setMap(int[][] map) {
		this.map = map;
		return this;
	}

	@Override
	public void render(int offsetX, int offsetY, Area area, RandomAreaPrototype generator) {
		
		for (int xSegment = 0; xSegment < 9; xSegment++) {
			for (int ySegment = 0; ySegment < 9; ySegment++) {
				
				if (this.map[ySegment][xSegment] == 1) {
					area.setTile(xSegment + offsetX, ySegment + offsetY, generator.getFloorPrototype().getClone());
				} else {
					area.setTile(xSegment + offsetX, ySegment + offsetY, generator.getWallPrototype().getClone());
				}
				
			}
		}
		
		area.setTile(4+offsetX, 4+offsetY, this.getPortalCell().getClone());
		AreaPortal prototypePortal = new AreaPortal();
		prototypePortal.setRemoteArea(this.remoteArea);
		prototypePortal.setRemotePortal(this.remotePortal);
		area.getTile()[4+offsetX][4+offsetY].setPortal(prototypePortal);
		AreaPortal prototypePortal2 = new AreaPortal();
		prototypePortal2.setThisPortalKey(this.portal);
		area.getTile()[4+offsetX][5+offsetY].setPortal(prototypePortal2);
		
	}

	public void setPortal(String portal) {
		this.portal = portal;
	}

	public String getPortal() {
		return portal;
	}

	public void setRemoteArea(String remoteArea) {
		this.remoteArea = remoteArea;
	}

	public String getRemoteArea() {
		return remoteArea;
	}

	public void setRemotePortal(String remotePortal) {
		this.remotePortal = remotePortal;
	}

	public String getRemotePortal() {
		return remotePortal;
	}

	public void setPortalCell(Cell portalCell) {
		this.portalCell = portalCell;
	}

	public Cell getPortalCell() {
		return portalCell;
	}

}
