package foh.rpg.area.factory.randomizer;

import foh.rpg.area.Area;

public class MatrixSegment extends Segment {
	
	private int[][] map = new int[9][9];
	
	public int[][] getMap() {
		return this.map;
	}

	public Segment setMap(int[][] map) {
		this.map = map;
		return this;
	}

	@Override
	public void render(int offsetX, int offsetY, Area area, RandomAreaPrototype generator) {
		
		for (int xSegment = 0; xSegment < 9; xSegment++) {
			for (int ySegment = 0; ySegment < 9; ySegment++) {
				
				if (this.map[ySegment][xSegment] == 1) {
					area.setTile(xSegment + offsetX, ySegment + offsetY, generator.getFloorPrototype().getClone());
				} else {
					area.setTile(xSegment + offsetX, ySegment + offsetY, generator.getWallPrototype().getClone());
				}
				
			}
		}
		
	}

}
