package foh.rpg.area.factory.randomizer;

import foh.rpg.area.Area;

public abstract class Segment {
	
	private SegmentConnector eastConnector = SegmentConnector.BLOCKED;
	private SegmentConnector westConnector = SegmentConnector.BLOCKED;
	private SegmentConnector northConnector = SegmentConnector.BLOCKED;
	private SegmentConnector southConnector = SegmentConnector.BLOCKED;
	
	public abstract void render(int xOffset, int yOffset, Area area, RandomAreaPrototype generator);

	public SegmentConnector getEastConnector() {
		return this.eastConnector;
	}

	public Segment setEastConnector(SegmentConnector eastConnector) {
		this.eastConnector = eastConnector;
		return this;
	}

	public SegmentConnector getWestConnector() {
		return this.westConnector;
	}

	public Segment setWestConnector(SegmentConnector westConnector) {
		this.westConnector = westConnector;
		return this;
	}

	public SegmentConnector getNorthConnector() {
		return this.northConnector;
	}

	public Segment setNorthConnector(SegmentConnector northConnector) {
		this.northConnector = northConnector;
		return this;
	}

	public SegmentConnector getSouthConnector() {
		return this.southConnector;
	}

	public Segment setSouthConnector(SegmentConnector southConnector) {
		this.southConnector = southConnector;
		return this;
	}

}
