package foh.rpg.character;

import java.util.ArrayList;
import java.util.List;

public enum Faction {

	PLAYER {
		@Override
		public List<Faction> getAllies() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(PLAYER);
			return list;
		}

		@Override
		public List<Faction> getFoes() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(DAEMON);
			list.add(EMPIRE_GUARDS);
			return list;
		}
	},
	
	FRIENDLY_NPC {

		@Override
		public List<Faction> getAllies() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(PLAYER);
			return list;
		}

		@Override
		public List<Faction> getFoes() {
			List<Faction> list = new ArrayList<Faction>();
			return list;
		}
		
	},


	DAEMON {
		@Override
		public List<Faction> getAllies() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(DAEMON);
			return list;
		}

		@Override
		public List<Faction> getFoes() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(PLAYER);
			list.add(EMPIRE_GUARDS);
			return list;
		}
	},

	EMPIRE_GUARDS {
		@Override
		public List<Faction> getAllies() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(EMPIRE_GUARDS);
			return list;
		}

		@Override
		public List<Faction> getFoes() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(PLAYER);
			list.add(DAEMON);
			return list;
		}
	},
	
	CRYSTAL_SPIDER {

		@Override
		public List<Faction> getAllies() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(CRYSTAL_SPIDER);
			return list;
		}

		@Override
		public List<Faction> getFoes() {
			List<Faction> list = new ArrayList<Faction>();
			list.add(PLAYER);
			return list;
		}
		
	};

	public abstract List<Faction> getAllies();
	public abstract List<Faction> getFoes();

}
