package foh.rpg.character.damage;

import java.util.ArrayList;
import java.util.List;

import foh.rpg.character.Actor;
import foh.rpg.character.xp.XPPacket;

/**
 * @author Zweistein
 */
public class DamagePacket {
	
	public DamagePacket() {
		this.damageChunks = new ArrayList<DamageChunk>();
	}

	private Actor originator;
	
	private List<DamageChunk> damageChunks;
	
	public int getTotalDamage() {
		int totalDamage = 0;
		
		for (DamageChunk damageChunk : this.damageChunks) {
			totalDamage += damageChunk.getDamageAmount();
		}
		
		return totalDamage;
	}

	public String toString() {
		return this.getTotalDamage()+"";
	}

	public Actor getOriginator() {
		return this.originator;
	}

	public void setOriginator(Actor originator) {
		this.originator = originator;
	}

	public List<DamageChunk> getDamageChunks() {
		return this.damageChunks;
	}

	
	public void processXP() {
		
		XPPacket xp = new XPPacket();
		
		for (DamageChunk chunk : this.damageChunks) {
			if (chunk.getOriginatingSkill() != null) {
				Integer amount = xp.getSkillXP().get(chunk.getOriginatingSkill());
				if (amount == null) {
					amount = 0;
				}
				amount = amount + 10;
				xp.getSkillXP().put(chunk.getOriginatingSkill(), amount);
			}
		}
		
		this.getOriginator().processXPPacket(xp);
		
	}
	

}