package foh.rpg.character.effect;

import java.util.ArrayList;
import java.util.List;

import foh.rpg.character.Actor;
import foh.rpg.character.damage.DamagePacket;
import foh.rpg.gui.Representation;
import foh.rpg.item.magical.AtomicProperty;

public class Effect {
	
	private Representation graphics;
	private EffectTimer timer;
	private List<AtomicProperty> properties;
	private Actor source;
	private Actor target;
	private String name;
	
	public Effect() {
		this.properties = new ArrayList<AtomicProperty>();
		this.timer = new EffectTimer();
	}

	public void tick() {
		timer.tick();
		for (AtomicProperty property : this.properties) {
			property.getType().onEffectTick(property, source, target);
		}
	}

	public void setTimer(EffectTimer timer) {
		this.timer = timer;
	}

	public EffectTimer getTimer() {
		return timer;
	}

	public boolean expired() {
		return this.timer.expired();
	}

	public void expire() {
	}

	public List<AtomicProperty> getProperties() {
		return this.properties;
	}

	public void setProperties(List<AtomicProperty> properties) {
		this.properties = properties;
	}

	public Actor getSource() {
		return this.source;
	}

	public void setSource(Actor source) {
		this.source = source;
	}

	public Actor getTarget() {
		return this.target;
	}

	public void setTarget(Actor target) {
		this.target = target;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void onEffectMeleeDamagePacketGeneration(DamagePacket packet) {
		for (AtomicProperty property : this.properties) {
			property.getType().onEffectMeleeDamagePacketGeneration(property, packet, source, target);
		}
	}

	public void setGraphics(Representation graphics) {
		this.graphics = graphics;
	}

	public Representation getGraphics() {
		return graphics;
	}

}
