package foh.rpg.character.effect;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import foh.rpg.character.Actor;
import foh.rpg.character.damage.DamagePacket;

public class EffectStack {
	
	private List<Effect> effects;
	
	public EffectStack() {
		this.effects = new LinkedList<Effect>();
	}
	
	public void tick() {
		for (Iterator<Effect> it = this.effects.iterator(); it.hasNext();) {
			Effect effect = it.next();
			effect.tick();
			if (effect.expired()) {
				effect.expire();
				it.remove();
			}
		}
	}

	public void setEffects(List<Effect> effects) {
		this.effects = effects;
	}

	public List<Effect> getEffects() {
		return effects;
	}

	public void add(Effect effect) {
		this.effects.add(effect);
	}

	public void onEffectMeleeDamagePacketGeneration(DamagePacket packet) {
		for (Effect effect : this.effects) {
			effect.onEffectMeleeDamagePacketGeneration(packet);
		}
	}

	public void setTarget(Actor target) {
		for (Effect effect : this.effects) {
			effect.setTarget(target);
		}
	}
	

}
