package foh.rpg.character.skill;

import foh.rpg.character.xp.XPGainer;
import foh.rpg.character.xp.XPPacket;
import foh.rpg.character.xp.XPToLevelTransator;


public class Skill implements XPGainer {
	
	private int xp;
	private int combatValue;
	private boolean marked;
	private SkillType type;
	
	public Skill(SkillType skillType) {
		this.type = skillType;
	}

	public int getCombatValue() {
		return this.combatValue;
	}
	
	public int getMaxValue() {
		return XPToLevelTransator.getLevelFromXP(this.xp);
	}

	public SkillType getType() {
		return this.type;
	}
	
	public boolean isMarked() {
		return this.marked;
	}
	
	public void setMarked(boolean marked) {
		this.marked = marked;
	}
	
	public void processXPPacket(XPPacket xp) {
		Integer XPForSkill = xp.getSkillXP().remove(this.getType());
		if (XPForSkill != null) {
			this.xp+=XPForSkill.intValue();
			
			//if xp overflow over max, we return it to pool of generix xp and turn off
			//mark
			if (this.xp > XPToLevelTransator.getMaxXP()) {
				xp.setRawXP(this.xp - XPToLevelTransator.getMaxXP());
				this.xp = XPToLevelTransator.getMaxXP();
				if (this.isMarked()) {
					this.setMarked(false);
				}
			}
		}
	}
	
	public int getXp() {
		return this.xp;
	}
	public void setXp(int xp) {
		this.xp = xp;
	}
	public void setCombatValue(int combatValue) {
		this.combatValue = combatValue;
	}

}
