package foh.rpg.character.xp;

public class XPToLevelTransator {
	
	private static int[] levels = { 62, 140, 300, 640, 1100, 2200, 4200, 7800, 14000,
			26000 };
	
	public static int getLevelFromXP (int xp) {
		for (int i = 0; i < levels.length; i++) {
			if (xp < levels[i]) {
				return i;
			}
		}
		return 10;
	}
	
	public static int getXPForNextLevel(int level) {
		if (level >= levels.length) {
			return getMaxXP();
		} else if (level < 0) {
			return 0;
		} else {
			return levels[level];
		}
	}
	
	public static int getMaxXP() {
		return levels[levels.length-1];
	}

}
