package foh.rpg.gui;

import java.awt.Color;
import java.awt.image.RGBImageFilter;

public class TileImageFilter extends RGBImageFilter {
	
	private Color color;
	private Color bgColor;

	public TileImageFilter(Color color, Color bgColor) {
		this.color = color;
		this.bgColor = bgColor;
	}

	@Override
	public int filterRGB(int x, int y, int rgb) {
		
	    int r = ((rgb >> 16) & 0xff);
	    int g = ((rgb >> 8) & 0xff);
	    int b = ((rgb >> 0) & 0xff);
		
		if (r == g && g == b) {
			
			float ratio = ((float)r)/255;
			
			int newR = (int) (color.getRed() * ratio) + (int) (bgColor.getRed() * (1 - ratio)); 
			int newG = (int) (color.getGreen() * ratio) + (int) (bgColor.getGreen() * (1 - ratio));
			int newB = (int) (color.getBlue() * ratio) + (int) (bgColor.getBlue() * (1 - ratio));
			
			return 0xff000000 | (newR << 16) | (newG << 8) | (newB << 0);
			
		} else {
			return rgb;
		}
	}

}
