package foh.rpg.gui.music;

import java.io.IOException;
import java.io.InputStream;

import javazoom.jl.decoder.JavaLayerException;
import javazoom.jl.player.Player;

public class MusicThread implements Runnable {

	private String request = null;
	private String currentTrack = null;
	private Player mp3Player;

	public void setRequest(String request) {
		if (!request.equals(currentTrack)) {
			this.request = request;
		}
	}

	@Override
	public void run() {

		try {

			while (true) {

				if (request != null) {
					// we switch track

					currentTrack = request;
					request = null;

					new Thread(new Runnable() {

						@Override
						public void run() {
							try {
								InputStream in = this.getClass()
										.getClassLoader().getResource(
												currentTrack).openStream();

								if (mp3Player != null) {
									mp3Player.close();
								}
								mp3Player = new Player(in);
								mp3Player.play();
							} catch (JavaLayerException e) {
								e.printStackTrace();
							} catch (IOException e) {
								e.printStackTrace();
							}
						}

					}).start();

				}

				if (mp3Player != null) {
					if (mp3Player.isComplete()) {
						// re-request track
						this.request = this.currentTrack;
					}
				}

				Thread.sleep(1000);

			}

		} catch (InterruptedException e) {
			e.printStackTrace();
		}

	}

}
