package foh.rpg.item.magical;

import java.util.ArrayList;
import java.util.List;

import foh.rpg.area.Cell;
import foh.rpg.character.Actor;
import foh.rpg.character.damage.DamagePacket;

public class MagicalProperty {
	
	private List<AtomicProperty> properties;
	private String prefix;
	private String suffix;

	public MagicalProperty() {
		this.properties = new ArrayList<AtomicProperty>();
	}

	public List<AtomicProperty> getProperties() {
		return this.properties;
	}

	public String getPrefix() {
		return this.prefix;
	}

	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}

	public String getSuffix() {
		return this.suffix;
	}

	public void setSuffix(String suffix) {
		this.suffix = suffix;
	}

	public boolean isPrefix() {
		return this.prefix != null;
	}

	public boolean isSuffix() {
		return this.suffix != null;
	}
	
	public void onMeleeDamagePacketGeneration(DamagePacket packet, Actor source, Actor target) {
		for (AtomicProperty property: this.properties) {
			property.getType().onMeleeDamagePacketGeneration(property, packet, source, target);
		}
	}
	
	public void onConsume(Actor user) {
		for (AtomicProperty property: this.properties) {
			property.getType().onConsume(property, user);
		}
		
	}

	public void onHit(Actor user, Actor target) {
		for (AtomicProperty property: this.properties) {
			property.getType().onHit(property, user, target);
		}
	}
	
	public void onCast(Actor user, Actor target) {
		for (AtomicProperty property: this.properties) {
			property.getType().onCast(property, user, target);
		}
	}
	
	public void onCast(Actor user, Cell target) {
		for (AtomicProperty property: this.properties) {
			property.getType().onCast(property, user, target);
		}
	}
	
}
