package foh.rpg.util;

import java.util.Random;

/**
 * @author Zweistein
 */
public class Dice {
	
	private int min;
	private int max;

	public Dice(int dices, int sides, int bonus) {
		this.min = dices + bonus;
		this.max = dices * sides + bonus;
	}
	
	public Dice(int min, int max) {
		this.min = min;
		this.max = max;
	}
	
	public String toString() {
		StringBuffer dice = new StringBuffer();

		dice.append(this.min);
		dice.append("-");
		dice.append(this.max);
		
		return dice.toString();
	}
	
	/**
	 * @return Returns minimun rollable value.
	 */
	public int getMin() {
		return this.min;
	}

	/**
	 * @return Returns maximun rollable value.
	 */
	public int getMax() {
		return this.max;
	}

	/**
	 * @return Returns random number which is result of dice roll.
	 */
	public int roll() {
		return new Random().nextInt( (this.getMax() - this.getMin()) + 1 ) + this.getMin();
	}

}
