package foh.rpg.util;

import com.martiansoftware.jsap.ParseException;
import com.martiansoftware.jsap.StringParser;

public class DiceStringParser extends StringParser {

	@Override
	public Object parse(String dice) throws ParseException {
		
		if (dice.indexOf("-") == -1 ) {
			int value = Integer.parseInt(dice);
			
			return new Dice(value, value);
			
		} else {
			
			String[] range = dice.split("-");
			
			int min = Integer.parseInt(range[0]);
			int max = Integer.parseInt(range[1]);
			
			return new Dice(min, max);
			
		}
		
	}
	
	public static DiceStringParser getParser() {
		return new DiceStringParser();
	}

}
