package foh.rpg.util;

import java.awt.Color;
import java.io.IOException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.martiansoftware.jsap.stringparsers.BooleanStringParser;
import com.martiansoftware.jsap.stringparsers.ColorStringParser;
import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public abstract class FactoryFromXML {
	
	protected JSAPReuse<Color> colorParser = new JSAPReuse<Color>(ColorStringParser.getParser());
	protected JSAPReuse<Boolean> booleanParser = new JSAPReuse<Boolean>(BooleanStringParser.getParser());
	protected JSAPReuse<Dice> diceParser = new JSAPReuse<Dice>(DiceStringParser.getParser());
	
	protected Document parseDocument(String file) {
		
		Document doc = null;
		
		try {
			
			InputSource source = new InputSource(this.getClass().getClassLoader().getResource(file).openStream());
			DOMParser parser = new DOMParser();
			parser.parse(source);
			doc = parser.getDocument();

		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}
		
		return doc;
	}
	
	protected Node getChildNode(Node parent, String child) {
		NodeList children = parent.getChildNodes();

		for (int i = 0; i < children.getLength(); i++) {
			if (child.equals(children.item(i).getLocalName())) {
				return children.item(i);
			}
		}
		
		return null;
	}

}
